unit OmegaZolnierz;

interface
uses
    OmegaImageList,OmegaSprite;
type

tZolnierz=class(TSprite)
  private
    fdVA,
    fIDAnimacji       :real;//wspolczynniki animacji
    fIdObrazKorpus,        //indeks obrazu z listy OmegaImageList
    fIdObrazGlowa,
    fIdObrazBron,
    fIdObrazTarcza,

    fIdKlatkaKorpus,        //indesk wycinanej klatki
    fIdKlatkaGlowa,
    fIdKlatkaBron,
    fIdKlatkaTarcza
                     :integer;

    fOffSetKierunku  :byte;//przesuniecie klatek animacji wynikajace z obranego kierunku ruchu
    fOmegaImageList  :TOmegaImageList;
    procedure RysujNaPolnoc;
    procedure RysujNaPoludnie;
    procedure RysujNaZachod;
    procedure RysujNaWschod;
    procedure Move(const MoveCount:single);override;
    procedure Draw;override;
  published
    property OffSetKierunku  :byte read fOffSetKierunku write fOffSetkierunku;
    property IdObrazKorpus   :integer read fIdObrazKorpus write fIdObrazKorpus;
    property IdObrazGlowa    :integer read fIdObrazGlowa  write fIdObrazGlowa;
    property IdObrazBron     :integer read fIdObrazBron   write fIdObrazBron;
    property IdObrazTarcza   :integer read fIdObrazTarcza write fIdObrazTarcza;

    property IdKlatkaKorpus   :integer read fIdKlatkaKorpus write fIdKlatkaKorpus;
    property IdKlatkaGlowa    :integer read fIdKlatkaGlowa  write fIdKlatkaGlowa;
    property IdKlatkaBron     :integer read fIdKlatkaBron   write fIdKlatkaBron;
    property IdKlatkaTarcza   :integer read fIdKlatkaTarcza write fIdKlatkaTarcza;

    property OmegaImageList   :TOmegaImageList read fOmegaImageList write fOmegaImageList;

  public

    constructor Create( const AParent: TOmegaSprite;
                        const AOmegaImageList: TOmegaImageList);virtual;
    procedure UstawObraz(Co :byte; const AIdObraz,AIdKlatka:integer);
end;
var
 Zolnierz:tZolnierz;
implementation
procedure tZolnierz.UstawObraz(Co :byte; const AIdObraz,AIdKlatka:integer);
begin
 case Co of
  0:begin IdObrazKorpus:=AIdObraz;
          Image:=OmegaImageList.ImageList.Items[fIdObrazKorpus];
          fIdKlatkaKorpus:=AidKlatka;
    end;
  1:begin IdObrazGlowa :=AIdObraz;IdKlatkaGlowa :=AIdKlatka;end;
  2:begin IdObrazBron  :=AIdObraz;IdKlatkaBron  :=AIdKlatka;end;
  3:begin IdObrazTarcza:=AIdObraz;IdKlatkaTarcza:=AIdKlatka;end;
 end;
end;
procedure tZolnierz.RysujNaPolnoc;
begin
 //Tarcza,Bron,Korpus, Glowa
 if fIdObrazTarcza>-1 then
 OmegaImageList.ImageList.Items[fIdObrazTarcza].Draw(Round(x),Round(y),Round(fIdKlatkaTarcza+fIDAnimacji+fOffSetKierunku));
 if fIdObrazBron>-1 then
 OmegaImageList.ImageList.Items[fIdObrazBron].Draw(Round(x),Round(y),Round(fIdKlatkaBron+fIDAnimacji+fOffSetKierunku));
 inherited Draw;//standardowa procedura rysujaca - tu bedzie rysowac korpus
 if fIdObrazGlowa>-1 then
 OmegaImageList.ImageList.Items[fIdObrazGlowa].Draw(Round(x),Round(y-16),Round(fIdKlatkaGlowa+fIDAnimacji+fOffSetKierunku));
end;
procedure tZolnierz.RysujNaPoludnie;
begin
 //Korpus,Glowa,Tarcza,Bron
 inherited Draw;//standardowa procedura rysujaca - tu bedzie rysowac korpus
 if fIdObrazGlowa>-1 then
 OmegaImageList.ImageList.Items[fIdObrazGlowa].Draw(Round(x),Round(y-16),Round(fIdKlatkaGlowa+fIDAnimacji+fOffSetKierunku));
 if fIdObrazTarcza>-1 then
 OmegaImageList.ImageList.Items[fIdObrazTarcza].Draw(Round(x),Round(y),Round(fIdKlatkaTarcza+fIDAnimacji+fOffSetKierunku));
 if fIdObrazBron>-1 then
 OmegaImageList.ImageList.Items[fIdObrazBron].Draw(Round(x),Round(y),Round(fIdKlatkaBron+fIDAnimacji+fOffSetKierunku));
end;
procedure tZolnierz.RysujNaWschod;
begin
 //Tarcza,Korpus,Glowa,Bron
 if fIdObrazTarcza>-1 then
 OmegaImageList.ImageList.Items[fIdObrazTarcza].Draw(Round(x),Round(y),Round(fIdKlatkaTarcza+fIDAnimacji+fOffSetKierunku));
 inherited Draw;//standardowa procedura rysujaca - tu bedzie rysowac korpus
 if fIdObrazGlowa>-1 then
 OmegaImageList.ImageList.Items[fIdObrazGlowa].Draw(Round(x),Round(y-16),Round(fIdKlatkaGlowa+fIDAnimacji+fOffSetKierunku));
 if fIdObrazBron>-1 then
 OmegaImageList.ImageList.Items[fIdObrazBron].Draw(Round(x),Round(y),Round(fIdKlatkaBron+fIDAnimacji+fOffSetKierunku));
end;
procedure tZolnierz.RysujNaZachod;
begin
 //Bron,Korpus,Glowa,Tarcza
 if fIdObrazBron>-1 then
 OmegaImageList.ImageList.Items[fIdObrazBron].Draw(Round(x),Round(y),Round(fIdKlatkaBron+fIDAnimacji+fOffSetKierunku));
 inherited Draw;//standardowa procedura rysujaca - tu bedzie rysowac korpus
 if fIdObrazGlowa>-1 then
 OmegaImageList.ImageList.Items[fIdObrazGlowa].Draw(Round(x),Round(y-16),Round(fIdKlatkaGlowa+fIDAnimacji+fOffSetKierunku));
 if fIdObrazTarcza>-1 then
 OmegaImageList.ImageList.Items[fIdObrazTarcza].Draw(Round(x),Round(y),Round(fIdKlatkaTarcza+fIDAnimacji+fOffSetKierunku));
end;

procedure tZolnierz.Draw;
begin
 if fIdKlatkaKorpus<0 then exit;
 ImageIndex:=Round(fIdKlatkaKorpus+fIDAnimacji+fOffSetKierunku);
 Case fOffSetKierunku of
 0:RysujNAPolnoc;
 3:RysujNaPoludnie;
 6:RysujNAZachod;
 9:RysujNaWschod;
 end;
end;

procedure tZolnierz.Move(const MoveCount:single);
begin
 if fIDAnimacji>2 then fIDAnimacji:=0;
 fIDAnimacji:=fIDAnimacji+fdVA*MoveCount;//fdVA to predkosc animacji
 inherited Move(MoveCount);
end;

constructor tZolnierz.Create( const AParent: TOmegaSprite;
                              const AOmegaImageList: TOmegaImageList);
begin
   inherited Create(AParent);
   OmegaImageList:=AOmegaImageList;
   fOffSetKierunku:=0;
   fDVA:=5;
   //usatw poczatkowe wartosci indeksw obrazw i ich klatek
   fIdObrazKorpus :=0;
   fIdObrazGlowa  :=-1;
   fIdObrazBron   :=-1;
   fIdObrazTarcza :=-1;

   fIdKlatkaKorpus:= 0;
   fIdKlatkaGlowa :=-1;
   fIdKlatkaBron  :=-1;
   fIdKlatkaTarcza:=-1;

   Image        :=OmegaImageList.ImageList.Items[fIdObrazKorpus];
   ImageIndex   :=fIdKlatkaKorpus;
   width        :=Image.TileWidth;
   height       :=Image.TileHeight;
   DoCollision  :=true;
   DoPixelCheck :=true;
end;

end.
